# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.add_archive_bucket_request_archive_bucket_storage_provider import AddArchiveBucketRequestArchiveBucketStorageProvider
from morpheus.models.get_alerts200_response_all_of_checks_inner_account import GetAlerts200ResponseAllOfChecksInnerAccount
from typing import Optional, Set
from typing_extensions import Self

class AddArchiveBucketRequestArchiveBucket(BaseModel):
    """
    AddArchiveBucketRequestArchiveBucket
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="A name for the archive bucket. Must be globally unique.")
    description: Optional[StrictStr] = Field(default=None, description="A description for the archive bucket")
    storage_provider: Optional[AddArchiveBucketRequestArchiveBucketStorageProvider] = Field(default=None, alias="storageProvider")
    visibility: Optional[StrictStr] = Field(default='private', description="Visibility - Set to public to allow all tenants")
    is_public: Optional[StrictBool] = Field(default=False, description="Public URL - Set to true to allow anonymous access", alias="isPublic")
    accounts: Optional[GetAlerts200ResponseAllOfChecksInnerAccount] = None
    __properties: ClassVar[List[str]] = ["name", "description", "storageProvider", "visibility", "isPublic", "accounts"]

    @field_validator('visibility')
    def visibility_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['public', 'private']):
            raise ValueError("must be one of enum values ('public', 'private')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddArchiveBucketRequestArchiveBucket from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of storage_provider
        if self.storage_provider:
            _dict['storageProvider'] = self.storage_provider.to_dict()
        # override the default output from pydantic by calling `to_dict()` of accounts
        if self.accounts:
            _dict['accounts'] = self.accounts.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddArchiveBucketRequestArchiveBucket from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "description": obj.get("description"),
            "storageProvider": AddArchiveBucketRequestArchiveBucketStorageProvider.from_dict(obj["storageProvider"]) if obj.get("storageProvider") is not None else None,
            "visibility": obj.get("visibility") if obj.get("visibility") is not None else 'private',
            "isPublic": obj.get("isPublic") if obj.get("isPublic") is not None else False,
            "accounts": GetAlerts200ResponseAllOfChecksInnerAccount.from_dict(obj["accounts"]) if obj.get("accounts") is not None else None
        })
        return _obj


