# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.add_blueprint_request_one_of_arm_cloud_init_enabled import AddBlueprintRequestOneOfArmCloudInitEnabled
from morpheus.models.add_blueprint_request_one_of_arm_git import AddBlueprintRequestOneOfArmGit
from morpheus.models.add_blueprint_request_one_of_arm_install_agent import AddBlueprintRequestOneOfArmInstallAgent
from typing import Optional, Set
from typing_extensions import Self

class AddBlueprintRequestOneOfArm(BaseModel):
    """
    AddBlueprintRequestOneOfArm
    """ # noqa: E501
    config_type: StrictStr = Field(description="Configuration Type", alias="configType")
    var_json: Optional[StrictStr] = Field(default=None, description="ARM Template in JSON", alias="json")
    yaml: Optional[StrictStr] = Field(default=None, description="ARM Template in YAML")
    git: Optional[AddBlueprintRequestOneOfArmGit] = None
    os_type: Optional[StrictStr] = Field(default=None, description="OS Type", alias="osType")
    install_agent: Optional[AddBlueprintRequestOneOfArmInstallAgent] = Field(default=None, alias="installAgent")
    cloud_init_enabled: Optional[AddBlueprintRequestOneOfArmCloudInitEnabled] = Field(default=None, alias="cloudInitEnabled")
    __properties: ClassVar[List[str]] = ["configType", "json", "yaml", "git", "osType", "installAgent", "cloudInitEnabled"]

    @field_validator('config_type')
    def config_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['json', 'yaml', 'git']):
            raise ValueError("must be one of enum values ('json', 'yaml', 'git')")
        return value

    @field_validator('os_type')
    def os_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['linux', 'windows']):
            raise ValueError("must be one of enum values ('linux', 'windows')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddBlueprintRequestOneOfArm from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of git
        if self.git:
            _dict['git'] = self.git.to_dict()
        # override the default output from pydantic by calling `to_dict()` of install_agent
        if self.install_agent:
            _dict['installAgent'] = self.install_agent.to_dict()
        # override the default output from pydantic by calling `to_dict()` of cloud_init_enabled
        if self.cloud_init_enabled:
            _dict['cloudInitEnabled'] = self.cloud_init_enabled.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddBlueprintRequestOneOfArm from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "configType": obj.get("configType"),
            "json": obj.get("json"),
            "yaml": obj.get("yaml"),
            "git": AddBlueprintRequestOneOfArmGit.from_dict(obj["git"]) if obj.get("git") is not None else None,
            "osType": obj.get("osType"),
            "installAgent": AddBlueprintRequestOneOfArmInstallAgent.from_dict(obj["installAgent"]) if obj.get("installAgent") is not None else None,
            "cloudInitEnabled": AddBlueprintRequestOneOfArmCloudInitEnabled.from_dict(obj["cloudInitEnabled"]) if obj.get("cloudInitEnabled") is not None else None
        })
        return _obj


