# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from morpheus.models.add_catalog_item_type_request_catalog_item_type_one_of import AddCatalogItemTypeRequestCatalogItemTypeOneOf
from morpheus.models.add_catalog_item_type_request_catalog_item_type_one_of1 import AddCatalogItemTypeRequestCatalogItemTypeOneOf1
from morpheus.models.add_catalog_item_type_request_catalog_item_type_one_of2 import AddCatalogItemTypeRequestCatalogItemTypeOneOf2
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

ADDCATALOGITEMTYPEREQUESTCATALOGITEMTYPE_ONE_OF_SCHEMAS = ["AddCatalogItemTypeRequestCatalogItemTypeOneOf", "AddCatalogItemTypeRequestCatalogItemTypeOneOf1", "AddCatalogItemTypeRequestCatalogItemTypeOneOf2"]

class AddCatalogItemTypeRequestCatalogItemType(BaseModel):
    """
    AddCatalogItemTypeRequestCatalogItemType
    """
    # data type: AddCatalogItemTypeRequestCatalogItemTypeOneOf
    oneof_schema_1_validator: Optional[AddCatalogItemTypeRequestCatalogItemTypeOneOf] = None
    # data type: AddCatalogItemTypeRequestCatalogItemTypeOneOf1
    oneof_schema_2_validator: Optional[AddCatalogItemTypeRequestCatalogItemTypeOneOf1] = None
    # data type: AddCatalogItemTypeRequestCatalogItemTypeOneOf2
    oneof_schema_3_validator: Optional[AddCatalogItemTypeRequestCatalogItemTypeOneOf2] = None
    actual_instance: Optional[Union[AddCatalogItemTypeRequestCatalogItemTypeOneOf, AddCatalogItemTypeRequestCatalogItemTypeOneOf1, AddCatalogItemTypeRequestCatalogItemTypeOneOf2]] = None
    one_of_schemas: Set[str] = { "AddCatalogItemTypeRequestCatalogItemTypeOneOf", "AddCatalogItemTypeRequestCatalogItemTypeOneOf1", "AddCatalogItemTypeRequestCatalogItemTypeOneOf2" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = AddCatalogItemTypeRequestCatalogItemType.model_construct()
        error_messages = []
        match = 0
        # validate data type: AddCatalogItemTypeRequestCatalogItemTypeOneOf
        if not isinstance(v, AddCatalogItemTypeRequestCatalogItemTypeOneOf):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddCatalogItemTypeRequestCatalogItemTypeOneOf`")
        else:
            match += 1
        # validate data type: AddCatalogItemTypeRequestCatalogItemTypeOneOf1
        if not isinstance(v, AddCatalogItemTypeRequestCatalogItemTypeOneOf1):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddCatalogItemTypeRequestCatalogItemTypeOneOf1`")
        else:
            match += 1
        # validate data type: AddCatalogItemTypeRequestCatalogItemTypeOneOf2
        if not isinstance(v, AddCatalogItemTypeRequestCatalogItemTypeOneOf2):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddCatalogItemTypeRequestCatalogItemTypeOneOf2`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in AddCatalogItemTypeRequestCatalogItemType with oneOf schemas: AddCatalogItemTypeRequestCatalogItemTypeOneOf, AddCatalogItemTypeRequestCatalogItemTypeOneOf1, AddCatalogItemTypeRequestCatalogItemTypeOneOf2. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in AddCatalogItemTypeRequestCatalogItemType with oneOf schemas: AddCatalogItemTypeRequestCatalogItemTypeOneOf, AddCatalogItemTypeRequestCatalogItemTypeOneOf1, AddCatalogItemTypeRequestCatalogItemTypeOneOf2. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into AddCatalogItemTypeRequestCatalogItemTypeOneOf
        try:
            instance.actual_instance = AddCatalogItemTypeRequestCatalogItemTypeOneOf.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddCatalogItemTypeRequestCatalogItemTypeOneOf1
        try:
            instance.actual_instance = AddCatalogItemTypeRequestCatalogItemTypeOneOf1.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddCatalogItemTypeRequestCatalogItemTypeOneOf2
        try:
            instance.actual_instance = AddCatalogItemTypeRequestCatalogItemTypeOneOf2.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into AddCatalogItemTypeRequestCatalogItemType with oneOf schemas: AddCatalogItemTypeRequestCatalogItemTypeOneOf, AddCatalogItemTypeRequestCatalogItemTypeOneOf1, AddCatalogItemTypeRequestCatalogItemTypeOneOf2. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into AddCatalogItemTypeRequestCatalogItemType with oneOf schemas: AddCatalogItemTypeRequestCatalogItemTypeOneOf, AddCatalogItemTypeRequestCatalogItemTypeOneOf1, AddCatalogItemTypeRequestCatalogItemTypeOneOf2. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AddCatalogItemTypeRequestCatalogItemTypeOneOf, AddCatalogItemTypeRequestCatalogItemTypeOneOf1, AddCatalogItemTypeRequestCatalogItemTypeOneOf2]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


