# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AddCertificateRequestCertificate(BaseModel):
    """
    AddCertificateRequestCertificate
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="A unique name scoped to your account for the key")
    description: Optional[StrictStr] = Field(default=None, description="A description of the certificate")
    cert_file: Optional[StrictStr] = Field(default=None, description="The contents of the certificate file", alias="certFile")
    key_file: Optional[StrictStr] = Field(default=None, description="The contents of the key file", alias="keyFile")
    chain_file: Optional[StrictStr] = Field(default=None, description="The contents of the root certificate file", alias="chainFile")
    domain_name: Optional[StrictStr] = Field(default=None, description="The domain name this certificate is tied to", alias="domainName")
    wildcard: Optional[StrictBool] = Field(default=False, description="Whether or not this certificate is a wildcard cert")
    type: Optional[StrictStr] = Field(default='internal', description="Certificate Type Code to create a certificate of a type other than the default 'internal'.")
    integration_id: Optional[StrictInt] = Field(default=None, description="ID of the Service (Trust Integration) to create the certificate with, if using a type other than 'internal'. eg. Internal, NSXT or Venafi", alias="integrationId")
    __properties: ClassVar[List[str]] = ["name", "description", "certFile", "keyFile", "chainFile", "domainName", "wildcard", "type", "integrationId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddCertificateRequestCertificate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddCertificateRequestCertificate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "description": obj.get("description"),
            "certFile": obj.get("certFile"),
            "keyFile": obj.get("keyFile"),
            "chainFile": obj.get("chainFile"),
            "domainName": obj.get("domainName"),
            "wildcard": obj.get("wildcard") if obj.get("wildcard") is not None else False,
            "type": obj.get("type") if obj.get("type") is not None else 'internal',
            "integrationId": obj.get("integrationId")
        })
        return _obj


