# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Optional
from morpheus.models.add_cloud_resource_pool_request_resource_pool_config_any_of import AddCloudResourcePoolRequestResourcePoolConfigAnyOf
from morpheus.models.add_cloud_resource_pool_request_resource_pool_config_any_of1 import AddCloudResourcePoolRequestResourcePoolConfigAnyOf1
from typing import Union, Any, List, Set, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal, Self
from pydantic import Field

ADDCLOUDRESOURCEPOOLREQUESTRESOURCEPOOLCONFIG_ANY_OF_SCHEMAS = ["AddCloudResourcePoolRequestResourcePoolConfigAnyOf", "AddCloudResourcePoolRequestResourcePoolConfigAnyOf1"]

class AddCloudResourcePoolRequestResourcePoolConfig(BaseModel):
    """
    AddCloudResourcePoolRequestResourcePoolConfig
    """

    # data type: AddCloudResourcePoolRequestResourcePoolConfigAnyOf
    anyof_schema_1_validator: Optional[AddCloudResourcePoolRequestResourcePoolConfigAnyOf] = None
    # data type: AddCloudResourcePoolRequestResourcePoolConfigAnyOf1
    anyof_schema_2_validator: Optional[AddCloudResourcePoolRequestResourcePoolConfigAnyOf1] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[AddCloudResourcePoolRequestResourcePoolConfigAnyOf, AddCloudResourcePoolRequestResourcePoolConfigAnyOf1]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: Set[str] = { "AddCloudResourcePoolRequestResourcePoolConfigAnyOf", "AddCloudResourcePoolRequestResourcePoolConfigAnyOf1" }

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = AddCloudResourcePoolRequestResourcePoolConfig.model_construct()
        error_messages = []
        # validate data type: AddCloudResourcePoolRequestResourcePoolConfigAnyOf
        if not isinstance(v, AddCloudResourcePoolRequestResourcePoolConfigAnyOf):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddCloudResourcePoolRequestResourcePoolConfigAnyOf`")
        else:
            return v

        # validate data type: AddCloudResourcePoolRequestResourcePoolConfigAnyOf1
        if not isinstance(v, AddCloudResourcePoolRequestResourcePoolConfigAnyOf1):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddCloudResourcePoolRequestResourcePoolConfigAnyOf1`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in AddCloudResourcePoolRequestResourcePoolConfig with anyOf schemas: AddCloudResourcePoolRequestResourcePoolConfigAnyOf, AddCloudResourcePoolRequestResourcePoolConfigAnyOf1. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[AddCloudResourcePoolRequestResourcePoolConfigAnyOf] = None
        try:
            instance.actual_instance = AddCloudResourcePoolRequestResourcePoolConfigAnyOf.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[AddCloudResourcePoolRequestResourcePoolConfigAnyOf1] = None
        try:
            instance.actual_instance = AddCloudResourcePoolRequestResourcePoolConfigAnyOf1.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into AddCloudResourcePoolRequestResourcePoolConfig with anyOf schemas: AddCloudResourcePoolRequestResourcePoolConfigAnyOf, AddCloudResourcePoolRequestResourcePoolConfigAnyOf1. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AddCloudResourcePoolRequestResourcePoolConfigAnyOf, AddCloudResourcePoolRequestResourcePoolConfigAnyOf1]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


