# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AddCredentialsRequestCredentialOneOf8Config(BaseModel):
    """
    AddCredentialsRequestCredentialOneOf8Config
    """ # noqa: E501
    grant_type: StrictStr = Field(description="OAuth 2.0 grant type", alias="grantType")
    access_token_url: StrictStr = Field(description="Token endpoint", alias="accessTokenUrl")
    client_id: Optional[StrictStr] = Field(default=None, description="Client ID", alias="clientId")
    client_secret: Optional[StrictStr] = Field(default=None, description="Client Secret", alias="clientSecret")
    scope: Optional[StrictStr] = Field(default=None, description="Scope")
    client_auth: StrictStr = Field(description="Client Authentication Method", alias="clientAuth")
    __properties: ClassVar[List[str]] = ["grantType", "accessTokenUrl", "clientId", "clientSecret", "scope", "clientAuth"]

    @field_validator('grant_type')
    def grant_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['password', 'client_credentials']):
            raise ValueError("must be one of enum values ('password', 'client_credentials')")
        return value

    @field_validator('client_auth')
    def client_auth_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['body', 'basic-auth']):
            raise ValueError("must be one of enum values ('body', 'basic-auth')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddCredentialsRequestCredentialOneOf8Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddCredentialsRequestCredentialOneOf8Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "grantType": obj.get("grantType"),
            "accessTokenUrl": obj.get("accessTokenUrl"),
            "clientId": obj.get("clientId"),
            "clientSecret": obj.get("clientSecret"),
            "scope": obj.get("scope"),
            "clientAuth": obj.get("clientAuth")
        })
        return _obj


