# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AddIntegrationsRequestOneOf2IntegrationConfig(BaseModel):
    """
    AddIntegrationsRequestOneOf2IntegrationConfig
    """ # noqa: E501
    service_now_custom_cmdb_mapping: Optional[List[Dict[str, Any]]] = Field(default=None, alias="serviceNowCustomCmdbMapping")
    service_now_cmdb_class_mapping: Optional[List[Dict[str, Any]]] = Field(default=None, alias="serviceNowCmdbClassMapping")
    service_now_cmdb_business_object: Optional[List[Dict[str, Any]]] = Field(default=None, alias="serviceNowCMDBBusinessObject")
    ignore_cert_errors: Optional[StrictBool] = Field(default=False, description="Ignore SSL Errors.", alias="ignoreCertErrors")
    cmdb_mode: Optional[StrictStr] = Field(default='TABLE', alias="cmdbMode")
    __properties: ClassVar[List[str]] = ["serviceNowCustomCmdbMapping", "serviceNowCmdbClassMapping", "serviceNowCMDBBusinessObject", "ignoreCertErrors", "cmdbMode"]

    @field_validator('cmdb_mode')
    def cmdb_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['TABLE', 'IRE']):
            raise ValueError("must be one of enum values ('TABLE', 'IRE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddIntegrationsRequestOneOf2IntegrationConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddIntegrationsRequestOneOf2IntegrationConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "serviceNowCustomCmdbMapping": obj.get("serviceNowCustomCmdbMapping"),
            "serviceNowCmdbClassMapping": obj.get("serviceNowCmdbClassMapping"),
            "serviceNowCMDBBusinessObject": obj.get("serviceNowCMDBBusinessObject"),
            "ignoreCertErrors": obj.get("ignoreCertErrors") if obj.get("ignoreCertErrors") is not None else False,
            "cmdbMode": obj.get("cmdbMode") if obj.get("cmdbMode") is not None else 'TABLE'
        })
        return _obj


