# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class AddPowerSchedules200ResponseAllOfSchedule(BaseModel):
    """
    AddPowerSchedules200ResponseAllOfSchedule
    """ # noqa: E501
    id: Optional[StrictInt] = None
    name: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    visibility: Optional[StrictStr] = None
    enabled: Optional[StrictBool] = None
    schedule_type: Optional[StrictStr] = Field(default=None, alias="scheduleType")
    schedule_timezone: Optional[StrictStr] = Field(default=None, alias="scheduleTimezone")
    monday_on: Optional[StrictInt] = Field(default=None, alias="mondayOn")
    monday_on_time: Optional[StrictStr] = Field(default=None, alias="mondayOnTime")
    monday_off: Optional[StrictInt] = Field(default=None, alias="mondayOff")
    monday_off_time: Optional[StrictStr] = Field(default=None, alias="mondayOffTime")
    tuesday_on: Optional[StrictInt] = Field(default=None, alias="tuesdayOn")
    tuesday_on_time: Optional[StrictStr] = Field(default=None, alias="tuesdayOnTime")
    tuesday_off: Optional[StrictInt] = Field(default=None, alias="tuesdayOff")
    tuesday_off_time: Optional[StrictStr] = Field(default=None, alias="tuesdayOffTime")
    wednesday_on: Optional[StrictInt] = Field(default=None, alias="wednesdayOn")
    wednesday_on_time: Optional[StrictStr] = Field(default=None, alias="wednesdayOnTime")
    wednesday_off: Optional[StrictInt] = Field(default=None, alias="wednesdayOff")
    wednesday_off_time: Optional[StrictStr] = Field(default=None, alias="wednesdayOffTime")
    thursday_on: Optional[StrictInt] = Field(default=None, alias="thursdayOn")
    thursday_on_time: Optional[StrictStr] = Field(default=None, alias="thursdayOnTime")
    thursday_off: Optional[StrictInt] = Field(default=None, alias="thursdayOff")
    thursday_off_time: Optional[StrictStr] = Field(default=None, alias="thursdayOffTime")
    friday_on: Optional[StrictInt] = Field(default=None, alias="fridayOn")
    friday_on_time: Optional[StrictStr] = Field(default=None, alias="fridayOnTime")
    friday_off: Optional[StrictInt] = Field(default=None, alias="fridayOff")
    friday_off_time: Optional[StrictStr] = Field(default=None, alias="fridayOffTime")
    saturday_on: Optional[StrictInt] = Field(default=None, alias="saturdayOn")
    saturday_on_time: Optional[StrictStr] = Field(default=None, alias="saturdayOnTime")
    saturday_off: Optional[StrictInt] = Field(default=None, alias="saturdayOff")
    saturday_off_time: Optional[StrictStr] = Field(default=None, alias="saturdayOffTime")
    sunday_on: Optional[StrictInt] = Field(default=None, alias="sundayOn")
    sunday_on_time: Optional[StrictStr] = Field(default=None, alias="sundayOnTime")
    sunday_off: Optional[StrictInt] = Field(default=None, alias="sundayOff")
    sunday_off_time: Optional[StrictStr] = Field(default=None, alias="sundayOffTime")
    total_monthly_hours_saved: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="totalMonthlyHoursSaved")
    date_created: Optional[datetime] = Field(default=None, alias="dateCreated")
    last_updated: Optional[datetime] = Field(default=None, alias="lastUpdated")
    __properties: ClassVar[List[str]] = ["id", "name", "description", "visibility", "enabled", "scheduleType", "scheduleTimezone", "mondayOn", "mondayOnTime", "mondayOff", "mondayOffTime", "tuesdayOn", "tuesdayOnTime", "tuesdayOff", "tuesdayOffTime", "wednesdayOn", "wednesdayOnTime", "wednesdayOff", "wednesdayOffTime", "thursdayOn", "thursdayOnTime", "thursdayOff", "thursdayOffTime", "fridayOn", "fridayOnTime", "fridayOff", "fridayOffTime", "saturdayOn", "saturdayOnTime", "saturdayOff", "saturdayOffTime", "sundayOn", "sundayOnTime", "sundayOff", "sundayOffTime", "totalMonthlyHoursSaved", "dateCreated", "lastUpdated"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddPowerSchedules200ResponseAllOfSchedule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddPowerSchedules200ResponseAllOfSchedule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "visibility": obj.get("visibility"),
            "enabled": obj.get("enabled"),
            "scheduleType": obj.get("scheduleType"),
            "scheduleTimezone": obj.get("scheduleTimezone"),
            "mondayOn": obj.get("mondayOn"),
            "mondayOnTime": obj.get("mondayOnTime"),
            "mondayOff": obj.get("mondayOff"),
            "mondayOffTime": obj.get("mondayOffTime"),
            "tuesdayOn": obj.get("tuesdayOn"),
            "tuesdayOnTime": obj.get("tuesdayOnTime"),
            "tuesdayOff": obj.get("tuesdayOff"),
            "tuesdayOffTime": obj.get("tuesdayOffTime"),
            "wednesdayOn": obj.get("wednesdayOn"),
            "wednesdayOnTime": obj.get("wednesdayOnTime"),
            "wednesdayOff": obj.get("wednesdayOff"),
            "wednesdayOffTime": obj.get("wednesdayOffTime"),
            "thursdayOn": obj.get("thursdayOn"),
            "thursdayOnTime": obj.get("thursdayOnTime"),
            "thursdayOff": obj.get("thursdayOff"),
            "thursdayOffTime": obj.get("thursdayOffTime"),
            "fridayOn": obj.get("fridayOn"),
            "fridayOnTime": obj.get("fridayOnTime"),
            "fridayOff": obj.get("fridayOff"),
            "fridayOffTime": obj.get("fridayOffTime"),
            "saturdayOn": obj.get("saturdayOn"),
            "saturdayOnTime": obj.get("saturdayOnTime"),
            "saturdayOff": obj.get("saturdayOff"),
            "saturdayOffTime": obj.get("saturdayOffTime"),
            "sundayOn": obj.get("sundayOn"),
            "sundayOnTime": obj.get("sundayOnTime"),
            "sundayOff": obj.get("sundayOff"),
            "sundayOffTime": obj.get("sundayOffTime"),
            "totalMonthlyHoursSaved": obj.get("totalMonthlyHoursSaved"),
            "dateCreated": obj.get("dateCreated"),
            "lastUpdated": obj.get("lastUpdated")
        })
        return _obj


