# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AddServicePlansRequestServicePlanConfigRanges(BaseModel):
    """
    AddServicePlansRequestServicePlanConfigRanges
    """ # noqa: E501
    min_storage: Optional[StrictStr] = Field(default=None, description="Custom min storage in GB", alias="minStorage")
    max_storage: Optional[StrictStr] = Field(default=None, description="Custom max storage in GB", alias="maxStorage")
    min_per_disk_size: Optional[StrictStr] = Field(default=None, description="Custom min per disk size in GB", alias="minPerDiskSize")
    max_per_disk_size: Optional[StrictStr] = Field(default=None, description="Custom max per disk size in GB", alias="maxPerDiskSize")
    min_memory: Optional[StrictInt] = Field(default=None, description="Custom min memory in bytes", alias="minMemory")
    max_memory: Optional[StrictInt] = Field(default=None, description="Custom max memory in bytes", alias="maxMemory")
    min_cores: Optional[StrictStr] = Field(default=None, description="Custom min cores", alias="minCores")
    max_cores: Optional[StrictStr] = Field(default=None, description="Custom max cores", alias="maxCores")
    min_sockets: Optional[StrictStr] = Field(default=None, description="Custom min sockets", alias="minSockets")
    max_sockets: Optional[StrictStr] = Field(default=None, description="Custom max sockets", alias="maxSockets")
    min_cores_per_socket: Optional[StrictStr] = Field(default=None, description="Custom min cores allowed per socket", alias="minCoresPerSocket")
    max_cores_per_socket: Optional[StrictStr] = Field(default=None, description="Custom max cores allowed per socket", alias="maxCoresPerSocket")
    __properties: ClassVar[List[str]] = ["minStorage", "maxStorage", "minPerDiskSize", "maxPerDiskSize", "minMemory", "maxMemory", "minCores", "maxCores", "minSockets", "maxSockets", "minCoresPerSocket", "maxCoresPerSocket"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddServicePlansRequestServicePlanConfigRanges from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddServicePlansRequestServicePlanConfigRanges from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "minStorage": obj.get("minStorage"),
            "maxStorage": obj.get("maxStorage"),
            "minPerDiskSize": obj.get("minPerDiskSize"),
            "maxPerDiskSize": obj.get("maxPerDiskSize"),
            "minMemory": obj.get("minMemory"),
            "maxMemory": obj.get("maxMemory"),
            "minCores": obj.get("minCores"),
            "maxCores": obj.get("maxCores"),
            "minSockets": obj.get("minSockets"),
            "maxSockets": obj.get("maxSockets"),
            "minCoresPerSocket": obj.get("minCoresPerSocket"),
            "maxCoresPerSocket": obj.get("maxCoresPerSocket")
        })
        return _obj


