# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.add_tasks_request_task_file_repository import AddTasksRequestTaskFileRepository
from typing import Optional, Set
from typing_extensions import Self

class AddTasksRequestTaskFile(BaseModel):
    """
    File, object specifying type and content, see File Object. This is required for task types that expect a script, having scriptable:true and an optionType of `type:\"file-content\"`. 
    """ # noqa: E501
    source_type: StrictStr = Field(description="File Source i.e. `local`, `repository`, `url`. Default is `local`.", alias="sourceType")
    content: Optional[StrictStr] = Field(default=None, description="File content, the script text. Only required when sourceType is `local`.")
    content_path: Optional[StrictStr] = Field(default=None, description="Content Path, the repo file location or url. Required when sourceType is `repository` or `url`.", alias="contentPath")
    content_ref: Optional[StrictStr] = Field(default=None, description="Content Ref, the branch/tag. Only used when sourceType is `repository`.", alias="contentRef")
    repository: Optional[AddTasksRequestTaskFileRepository] = None
    __properties: ClassVar[List[str]] = ["sourceType", "content", "contentPath", "contentRef", "repository"]

    @field_validator('source_type')
    def source_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['local', 'repository', 'url']):
            raise ValueError("must be one of enum values ('local', 'repository', 'url')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddTasksRequestTaskFile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of repository
        if self.repository:
            _dict['repository'] = self.repository.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddTasksRequestTaskFile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sourceType": obj.get("sourceType") if obj.get("sourceType") is not None else 'local',
            "content": obj.get("content"),
            "contentPath": obj.get("contentPath"),
            "contentRef": obj.get("contentRef"),
            "repository": AddTasksRequestTaskFileRepository.from_dict(obj["repository"]) if obj.get("repository") is not None else None
        })
        return _obj


