# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Optional
from morpheus.models.add_vdi_pools200_response_any_of import AddVDIPools200ResponseAnyOf
from morpheus.models.delete_alerts200_response import DeleteAlerts200Response
from typing import Union, Any, List, Set, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal, Self
from pydantic import Field

ADDVDIPOOLS200RESPONSE_ANY_OF_SCHEMAS = ["AddVDIPools200ResponseAnyOf", "DeleteAlerts200Response"]

class AddVDIPools200Response(BaseModel):
    """
    AddVDIPools200Response
    """

    # data type: AddVDIPools200ResponseAnyOf
    anyof_schema_1_validator: Optional[AddVDIPools200ResponseAnyOf] = None
    # data type: DeleteAlerts200Response
    anyof_schema_2_validator: Optional[DeleteAlerts200Response] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[AddVDIPools200ResponseAnyOf, DeleteAlerts200Response]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: Set[str] = { "AddVDIPools200ResponseAnyOf", "DeleteAlerts200Response" }

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = AddVDIPools200Response.model_construct()
        error_messages = []
        # validate data type: AddVDIPools200ResponseAnyOf
        if not isinstance(v, AddVDIPools200ResponseAnyOf):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddVDIPools200ResponseAnyOf`")
        else:
            return v

        # validate data type: DeleteAlerts200Response
        if not isinstance(v, DeleteAlerts200Response):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DeleteAlerts200Response`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in AddVDIPools200Response with anyOf schemas: AddVDIPools200ResponseAnyOf, DeleteAlerts200Response. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[AddVDIPools200ResponseAnyOf] = None
        try:
            instance.actual_instance = AddVDIPools200ResponseAnyOf.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[DeleteAlerts200Response] = None
        try:
            instance.actual_instance = DeleteAlerts200Response.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into AddVDIPools200Response with anyOf schemas: AddVDIPools200ResponseAnyOf, DeleteAlerts200Response. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AddVDIPools200ResponseAnyOf, DeleteAlerts200Response]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


