# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.get_alerts200_response_all_of_check_groups_inner_instance import GetAlerts200ResponseAllOfCheckGroupsInnerInstance
from morpheus.models.list_backup_settings200_response_backup_settings_default_schedule import ListBackupSettings200ResponseBackupSettingsDefaultSchedule
from typing import Optional, Set
from typing_extensions import Self

class BackupSettings(BaseModel):
    """
    BackupSettings
    """ # noqa: E501
    backups_enabled: Optional[StrictBool] = Field(default=None, alias="backupsEnabled")
    create_backups: Optional[StrictBool] = Field(default=None, alias="createBackups")
    backup_appliance: Optional[StrictBool] = Field(default=None, alias="backupAppliance")
    default_storage_bucket: Optional[GetAlerts200ResponseAllOfCheckGroupsInnerInstance] = Field(default=None, alias="defaultStorageBucket")
    default_schedule: Optional[ListBackupSettings200ResponseBackupSettingsDefaultSchedule] = Field(default=None, alias="defaultSchedule")
    retention_count: Optional[StrictInt] = Field(default=None, alias="retentionCount")
    __properties: ClassVar[List[str]] = ["backupsEnabled", "createBackups", "backupAppliance", "defaultStorageBucket", "defaultSchedule", "retentionCount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BackupSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of default_storage_bucket
        if self.default_storage_bucket:
            _dict['defaultStorageBucket'] = self.default_storage_bucket.to_dict()
        # override the default output from pydantic by calling `to_dict()` of default_schedule
        if self.default_schedule:
            _dict['defaultSchedule'] = self.default_schedule.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BackupSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "backupsEnabled": obj.get("backupsEnabled"),
            "createBackups": obj.get("createBackups"),
            "backupAppliance": obj.get("backupAppliance"),
            "defaultStorageBucket": GetAlerts200ResponseAllOfCheckGroupsInnerInstance.from_dict(obj["defaultStorageBucket"]) if obj.get("defaultStorageBucket") is not None else None,
            "defaultSchedule": ListBackupSettings200ResponseBackupSettingsDefaultSchedule.from_dict(obj["defaultSchedule"]) if obj.get("defaultSchedule") is not None else None,
            "retentionCount": obj.get("retentionCount")
        })
        return _obj


