# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.list_load_balancer_pools200_response_all_of_load_balancer_pools_inner import ListLoadBalancerPools200ResponseAllOfLoadBalancerPoolsInner
from typing import Optional, Set
from typing_extensions import Self

class CreateLoadBalancerPool200Response(BaseModel):
    """
    CreateLoadBalancerPool200Response
    """ # noqa: E501
    load_balancer_pool: Optional[ListLoadBalancerPools200ResponseAllOfLoadBalancerPoolsInner] = Field(default=None, alias="loadBalancerPool")
    success: Optional[StrictBool] = None
    msg: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["loadBalancerPool", "success", "msg"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateLoadBalancerPool200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of load_balancer_pool
        if self.load_balancer_pool:
            _dict['loadBalancerPool'] = self.load_balancer_pool.to_dict()
        # set to None if msg (nullable) is None
        # and model_fields_set contains the field
        if self.msg is None and "msg" in self.model_fields_set:
            _dict['msg'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateLoadBalancerPool200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "loadBalancerPool": ListLoadBalancerPools200ResponseAllOfLoadBalancerPoolsInner.from_dict(obj["loadBalancerPool"]) if obj.get("loadBalancerPool") is not None else None,
            "success": obj.get("success"),
            "msg": obj.get("msg")
        })
        return _obj


