# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.get_archive_file_links200_response_all_of_archive_file_links_inner_archive_file import GetArchiveFileLinks200ResponseAllOfArchiveFileLinksInnerArchiveFile
from morpheus.models.list_archive_buckets200_response_all_of_archive_buckets_inner_created_by import ListArchiveBuckets200ResponseAllOfArchiveBucketsInnerCreatedBy
from typing import Optional, Set
from typing_extensions import Self

class GetArchiveFileLinks200ResponseAllOfArchiveFileLinksInner(BaseModel):
    """
    GetArchiveFileLinks200ResponseAllOfArchiveFileLinksInner
    """ # noqa: E501
    id: Optional[StrictInt] = None
    secret_access_key: Optional[StrictStr] = Field(default=None, alias="secretAccessKey")
    archive_file: Optional[GetArchiveFileLinks200ResponseAllOfArchiveFileLinksInnerArchiveFile] = Field(default=None, alias="archiveFile")
    created_by: Optional[ListArchiveBuckets200ResponseAllOfArchiveBucketsInnerCreatedBy] = Field(default=None, alias="createdBy")
    date_created: Optional[datetime] = Field(default=None, alias="dateCreated")
    last_updated: Optional[datetime] = Field(default=None, alias="lastUpdated")
    last_access_date: Optional[datetime] = Field(default=None, alias="lastAccessDate")
    expiration_date: Optional[datetime] = Field(default=None, alias="expirationDate")
    download_count: Optional[StrictInt] = Field(default=None, alias="downloadCount")
    __properties: ClassVar[List[str]] = ["id", "secretAccessKey", "archiveFile", "createdBy", "dateCreated", "lastUpdated", "lastAccessDate", "expirationDate", "downloadCount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetArchiveFileLinks200ResponseAllOfArchiveFileLinksInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of archive_file
        if self.archive_file:
            _dict['archiveFile'] = self.archive_file.to_dict()
        # override the default output from pydantic by calling `to_dict()` of created_by
        if self.created_by:
            _dict['createdBy'] = self.created_by.to_dict()
        # set to None if last_access_date (nullable) is None
        # and model_fields_set contains the field
        if self.last_access_date is None and "last_access_date" in self.model_fields_set:
            _dict['lastAccessDate'] = None

        # set to None if expiration_date (nullable) is None
        # and model_fields_set contains the field
        if self.expiration_date is None and "expiration_date" in self.model_fields_set:
            _dict['expirationDate'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetArchiveFileLinks200ResponseAllOfArchiveFileLinksInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "secretAccessKey": obj.get("secretAccessKey"),
            "archiveFile": GetArchiveFileLinks200ResponseAllOfArchiveFileLinksInnerArchiveFile.from_dict(obj["archiveFile"]) if obj.get("archiveFile") is not None else None,
            "createdBy": ListArchiveBuckets200ResponseAllOfArchiveBucketsInnerCreatedBy.from_dict(obj["createdBy"]) if obj.get("createdBy") is not None else None,
            "dateCreated": obj.get("dateCreated"),
            "lastUpdated": obj.get("lastUpdated"),
            "lastAccessDate": obj.get("lastAccessDate"),
            "expirationDate": obj.get("expirationDate"),
            "downloadCount": obj.get("downloadCount")
        })
        return _obj


