# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.get_guidance_stats200_response_stats_severity import GetGuidanceStats200ResponseStatsSeverity
from morpheus.models.get_guidance_stats200_response_stats_type import GetGuidanceStats200ResponseStatsType
from morpheus.models.list_guidances200_response_all_of_discoveries_inner_any_of_savings import ListGuidances200ResponseAllOfDiscoveriesInnerAnyOfSavings
from typing import Optional, Set
from typing_extensions import Self

class GetGuidanceStats200ResponseStats(BaseModel):
    """
    GetGuidanceStats200ResponseStats
    """ # noqa: E501
    total: Optional[StrictInt] = None
    savings: Optional[ListGuidances200ResponseAllOfDiscoveriesInnerAnyOfSavings] = None
    severity: Optional[GetGuidanceStats200ResponseStatsSeverity] = None
    type: Optional[GetGuidanceStats200ResponseStatsType] = None
    __properties: ClassVar[List[str]] = ["total", "savings", "severity", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetGuidanceStats200ResponseStats from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of savings
        if self.savings:
            _dict['savings'] = self.savings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of severity
        if self.severity:
            _dict['severity'] = self.severity.to_dict()
        # override the default output from pydantic by calling `to_dict()` of type
        if self.type:
            _dict['type'] = self.type.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetGuidanceStats200ResponseStats from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "total": obj.get("total"),
            "savings": ListGuidances200ResponseAllOfDiscoveriesInnerAnyOfSavings.from_dict(obj["savings"]) if obj.get("savings") is not None else None,
            "severity": GetGuidanceStats200ResponseStatsSeverity.from_dict(obj["severity"]) if obj.get("severity") is not None else None,
            "type": GetGuidanceStats200ResponseStatsType.from_dict(obj["type"]) if obj.get("type") is not None else None
        })
        return _obj


