# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class GetInstanceStats200ResponseInstanceStats(BaseModel):
    """
    GetInstanceStats200ResponseInstanceStats
    """ # noqa: E501
    max_cpu: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total CPUs for all instances", alias="maxCpu")
    max_cores: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total cores for all instances", alias="maxCores")
    cpu_usage_average: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Average current CPU Usage across all instances", alias="cpuUsageAverage")
    cpu_usage_peak: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Max current CPU Usage across all instances", alias="cpuUsagePeak")
    used_memory: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total used memory across all instances", alias="usedMemory")
    max_memory: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total memory across all instances", alias="maxMemory")
    used_storage: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total used storage total across all instances", alias="usedStorage")
    max_storage: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total storage across all instances", alias="maxStorage")
    running: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total number of running instances")
    total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total number of instances")
    total_containers: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total number of containers across all instances", alias="totalContainers")
    __properties: ClassVar[List[str]] = ["maxCpu", "maxCores", "cpuUsageAverage", "cpuUsagePeak", "usedMemory", "maxMemory", "usedStorage", "maxStorage", "running", "total", "totalContainers"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetInstanceStats200ResponseInstanceStats from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetInstanceStats200ResponseInstanceStats from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "maxCpu": obj.get("maxCpu"),
            "maxCores": obj.get("maxCores"),
            "cpuUsageAverage": obj.get("cpuUsageAverage"),
            "cpuUsagePeak": obj.get("cpuUsagePeak"),
            "usedMemory": obj.get("usedMemory"),
            "maxMemory": obj.get("maxMemory"),
            "usedStorage": obj.get("usedStorage"),
            "maxStorage": obj.get("maxStorage"),
            "running": obj.get("running"),
            "total": obj.get("total"),
            "totalContainers": obj.get("totalContainers")
        })
        return _obj


