# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.list_backup_settings200_response_backup_settings_default_schedule import ListBackupSettings200ResponseBackupSettingsDefaultSchedule
from typing import Optional, Set
from typing_extensions import Self

class GetNetworkRouters200ResponseNetworkRoutersInnerInterfacesInner(BaseModel):
    """
    GetNetworkRouters200ResponseNetworkRoutersInnerInterfacesInner
    """ # noqa: E501
    id: Optional[StrictInt] = None
    name: Optional[StrictStr] = None
    code: Optional[StrictStr] = None
    interface_type: Optional[StrictStr] = Field(default=None, alias="interfaceType")
    network_position: Optional[StrictStr] = Field(default=None, alias="networkPosition")
    ip_address: Optional[StrictStr] = Field(default=None, alias="ipAddress")
    cidr: Optional[StrictStr] = None
    external_link: Optional[StrictStr] = Field(default=None, alias="externalLink")
    enabled: Optional[StrictBool] = None
    network: Optional[ListBackupSettings200ResponseBackupSettingsDefaultSchedule] = None
    __properties: ClassVar[List[str]] = ["id", "name", "code", "interfaceType", "networkPosition", "ipAddress", "cidr", "externalLink", "enabled", "network"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetNetworkRouters200ResponseNetworkRoutersInnerInterfacesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of network
        if self.network:
            _dict['network'] = self.network.to_dict()
        # set to None if code (nullable) is None
        # and model_fields_set contains the field
        if self.code is None and "code" in self.model_fields_set:
            _dict['code'] = None

        # set to None if interface_type (nullable) is None
        # and model_fields_set contains the field
        if self.interface_type is None and "interface_type" in self.model_fields_set:
            _dict['interfaceType'] = None

        # set to None if network_position (nullable) is None
        # and model_fields_set contains the field
        if self.network_position is None and "network_position" in self.model_fields_set:
            _dict['networkPosition'] = None

        # set to None if external_link (nullable) is None
        # and model_fields_set contains the field
        if self.external_link is None and "external_link" in self.model_fields_set:
            _dict['externalLink'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetNetworkRouters200ResponseNetworkRoutersInnerInterfacesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "code": obj.get("code"),
            "interfaceType": obj.get("interfaceType"),
            "networkPosition": obj.get("networkPosition"),
            "ipAddress": obj.get("ipAddress"),
            "cidr": obj.get("cidr"),
            "externalLink": obj.get("externalLink"),
            "enabled": obj.get("enabled"),
            "network": ListBackupSettings200ResponseBackupSettingsDefaultSchedule.from_dict(obj["network"]) if obj.get("network") is not None else None
        })
        return _obj


