# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.get_app_state200_response_all_of_output import GetAppState200ResponseAllOfOutput
from morpheus.models.get_state_instance200_response_all_of_instance_input import GetStateInstance200ResponseAllOfInstanceInput
from typing import Optional, Set
from typing_extensions import Self

class GetStateInstance200ResponseAllOfInstance(BaseModel):
    """
    GetStateInstance200ResponseAllOfInstance
    """ # noqa: E501
    workloads: Optional[List[Dict[str, Any]]] = None
    iac_drift: Optional[StrictBool] = Field(default=None, alias="iacDrift")
    plan_resources: Optional[List[Dict[str, Any]]] = Field(default=None, alias="planResources")
    specs: Optional[List[Dict[str, Any]]] = None
    state_data: Optional[StrictStr] = Field(default=None, alias="stateData")
    plan_data: Optional[StrictStr] = Field(default=None, alias="planData")
    input: Optional[GetStateInstance200ResponseAllOfInstanceInput] = None
    output: Optional[GetAppState200ResponseAllOfOutput] = None
    __properties: ClassVar[List[str]] = ["workloads", "iacDrift", "planResources", "specs", "stateData", "planData", "input", "output"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetStateInstance200ResponseAllOfInstance from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of input
        if self.input:
            _dict['input'] = self.input.to_dict()
        # override the default output from pydantic by calling `to_dict()` of output
        if self.output:
            _dict['output'] = self.output.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetStateInstance200ResponseAllOfInstance from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "workloads": obj.get("workloads"),
            "iacDrift": obj.get("iacDrift"),
            "planResources": obj.get("planResources"),
            "specs": obj.get("specs"),
            "stateData": obj.get("stateData"),
            "planData": obj.get("planData"),
            "input": GetStateInstance200ResponseAllOfInstanceInput.from_dict(obj["input"]) if obj.get("input") is not None else None,
            "output": GetAppState200ResponseAllOfOutput.from_dict(obj["output"]) if obj.get("output") is not None else None
        })
        return _obj


