# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class HealthLogs(BaseModel):
    """
    HealthLogs
    """ # noqa: E501
    type_code: Optional[StrictStr] = Field(default=None, alias="typeCode")
    ts: Optional[datetime] = None
    level: Optional[StrictStr] = None
    source_type: Optional[StrictStr] = Field(default=None, alias="sourceType")
    message: Optional[StrictStr] = None
    hostname: Optional[StrictStr] = None
    title: Optional[StrictStr] = None
    log_signature: Optional[StrictStr] = Field(default=None, alias="logSignature")
    object_id: Optional[StrictStr] = Field(default=None, alias="objectId")
    seq: Optional[StrictInt] = None
    id: Optional[StrictStr] = Field(default=None, alias="_id")
    signature_verified: Optional[StrictBool] = Field(default=None, alias="signatureVerified")
    __properties: ClassVar[List[str]] = ["typeCode", "ts", "level", "sourceType", "message", "hostname", "title", "logSignature", "objectId", "seq", "_id", "signatureVerified"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of HealthLogs from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of HealthLogs from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "typeCode": obj.get("typeCode"),
            "ts": obj.get("ts"),
            "level": obj.get("level"),
            "sourceType": obj.get("sourceType"),
            "message": obj.get("message"),
            "hostname": obj.get("hostname"),
            "title": obj.get("title"),
            "logSignature": obj.get("logSignature"),
            "objectId": obj.get("objectId"),
            "seq": obj.get("seq"),
            "_id": obj.get("_id"),
            "signatureVerified": obj.get("signatureVerified")
        })
        return _obj


