# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.add_catalog_item_type_request_catalog_item_type_one_of_config_network_interfaces_inner import AddCatalogItemTypeRequestCatalogItemTypeOneOfConfigNetworkInterfacesInner
from morpheus.models.add_catalog_item_type_request_catalog_item_type_one_of_config_service_plan_options import AddCatalogItemTypeRequestCatalogItemTypeOneOfConfigServicePlanOptions
from morpheus.models.add_catalog_item_type_request_catalog_item_type_one_of_config_volumes_inner import AddCatalogItemTypeRequestCatalogItemTypeOneOfConfigVolumesInner
from morpheus.models.resize_instance_request_instance import ResizeInstanceRequestInstance
from typing import Optional, Set
from typing_extensions import Self

class InstanceResize(BaseModel):
    """
    InstanceResize
    """ # noqa: E501
    instance: Optional[ResizeInstanceRequestInstance] = None
    service_plan_options: Optional[AddCatalogItemTypeRequestCatalogItemTypeOneOfConfigServicePlanOptions] = Field(default=None, alias="servicePlanOptions")
    volumes: Optional[List[AddCatalogItemTypeRequestCatalogItemTypeOneOfConfigVolumesInner]] = Field(default=None, description="Can be used to grow just the logical volume of the instance instead of choosing a plan")
    delete_original_volumes: Optional[StrictBool] = Field(default=False, description="Delete the original volumes after resizing. (Amazon only)", alias="deleteOriginalVolumes")
    network_interfaces: Optional[List[AddCatalogItemTypeRequestCatalogItemTypeOneOfConfigNetworkInterfacesInner]] = Field(default=None, description="Key for network configuration. Include id to update an existing interface. The existing interfaces and their id can be retrieved with the hosts API.", alias="networkInterfaces")
    __properties: ClassVar[List[str]] = ["instance", "servicePlanOptions", "volumes", "deleteOriginalVolumes", "networkInterfaces"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of InstanceResize from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of instance
        if self.instance:
            _dict['instance'] = self.instance.to_dict()
        # override the default output from pydantic by calling `to_dict()` of service_plan_options
        if self.service_plan_options:
            _dict['servicePlanOptions'] = self.service_plan_options.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in volumes (list)
        _items = []
        if self.volumes:
            for _item_volumes in self.volumes:
                if _item_volumes:
                    _items.append(_item_volumes.to_dict())
            _dict['volumes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in network_interfaces (list)
        _items = []
        if self.network_interfaces:
            for _item_network_interfaces in self.network_interfaces:
                if _item_network_interfaces:
                    _items.append(_item_network_interfaces.to_dict())
            _dict['networkInterfaces'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of InstanceResize from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "instance": ResizeInstanceRequestInstance.from_dict(obj["instance"]) if obj.get("instance") is not None else None,
            "servicePlanOptions": AddCatalogItemTypeRequestCatalogItemTypeOneOfConfigServicePlanOptions.from_dict(obj["servicePlanOptions"]) if obj.get("servicePlanOptions") is not None else None,
            "volumes": [AddCatalogItemTypeRequestCatalogItemTypeOneOfConfigVolumesInner.from_dict(_item) for _item in obj["volumes"]] if obj.get("volumes") is not None else None,
            "deleteOriginalVolumes": obj.get("deleteOriginalVolumes") if obj.get("deleteOriginalVolumes") is not None else False,
            "networkInterfaces": [AddCatalogItemTypeRequestCatalogItemTypeOneOfConfigNetworkInterfacesInner.from_dict(_item) for _item in obj["networkInterfaces"]] if obj.get("networkInterfaces") is not None else None
        })
        return _obj


