# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.get_license200_response_current_usage import GetLicense200ResponseCurrentUsage
from morpheus.models.get_license200_response_installed_licenses_inner import GetLicense200ResponseInstalledLicensesInner
from morpheus.models.get_license200_response_license import GetLicense200ResponseLicense
from typing import Optional, Set
from typing_extensions import Self

class License(BaseModel):
    """
    License
    """ # noqa: E501
    license: Optional[GetLicense200ResponseLicense] = None
    installed_licenses: Optional[List[GetLicense200ResponseInstalledLicensesInner]] = Field(default=None, description="List of all the installed licenses", alias="installedLicenses")
    current_usage: Optional[GetLicense200ResponseCurrentUsage] = Field(default=None, alias="currentUsage")
    __properties: ClassVar[List[str]] = ["license", "installedLicenses", "currentUsage"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of License from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of license
        if self.license:
            _dict['license'] = self.license.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in installed_licenses (list)
        _items = []
        if self.installed_licenses:
            for _item_installed_licenses in self.installed_licenses:
                if _item_installed_licenses:
                    _items.append(_item_installed_licenses.to_dict())
            _dict['installedLicenses'] = _items
        # override the default output from pydantic by calling `to_dict()` of current_usage
        if self.current_usage:
            _dict['currentUsage'] = self.current_usage.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of License from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "license": GetLicense200ResponseLicense.from_dict(obj["license"]) if obj.get("license") is not None else None,
            "installedLicenses": [GetLicense200ResponseInstalledLicensesInner.from_dict(_item) for _item in obj["installedLicenses"]] if obj.get("installedLicenses") is not None else None,
            "currentUsage": GetLicense200ResponseCurrentUsage.from_dict(obj["currentUsage"]) if obj.get("currentUsage") is not None else None
        })
        return _obj


