# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from morpheus.models.list_billing_instances200_response_all_of_billing_info_instances_inner_containers_inner import ListBillingInstances200ResponseAllOfBillingInfoInstancesInnerContainersInner
from typing import Optional, Set
from typing_extensions import Self

class ListBillingInstances200ResponseAllOfBillingInfoInstancesInner(BaseModel):
    """
    ListBillingInstances200ResponseAllOfBillingInfoInstancesInner
    """ # noqa: E501
    instance_id: Optional[StrictInt] = Field(default=None, alias="instanceId")
    instance_uuid: Optional[StrictStr] = Field(default=None, alias="instanceUUID")
    start_date: Optional[datetime] = Field(default=None, alias="startDate")
    end_date: Optional[datetime] = Field(default=None, alias="endDate")
    name: Optional[StrictStr] = None
    price: Optional[Union[StrictFloat, StrictInt]] = None
    cost: Optional[Union[StrictFloat, StrictInt]] = None
    currency: Optional[StrictStr] = None
    containers: Optional[List[ListBillingInstances200ResponseAllOfBillingInfoInstancesInnerContainersInner]] = None
    __properties: ClassVar[List[str]] = ["instanceId", "instanceUUID", "startDate", "endDate", "name", "price", "cost", "currency", "containers"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListBillingInstances200ResponseAllOfBillingInfoInstancesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in containers (list)
        _items = []
        if self.containers:
            for _item_containers in self.containers:
                if _item_containers:
                    _items.append(_item_containers.to_dict())
            _dict['containers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListBillingInstances200ResponseAllOfBillingInfoInstancesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "instanceId": obj.get("instanceId"),
            "instanceUUID": obj.get("instanceUUID"),
            "startDate": obj.get("startDate"),
            "endDate": obj.get("endDate"),
            "name": obj.get("name"),
            "price": obj.get("price"),
            "cost": obj.get("cost"),
            "currency": obj.get("currency"),
            "containers": [ListBillingInstances200ResponseAllOfBillingInfoInstancesInnerContainersInner.from_dict(_item) for _item in obj["containers"]] if obj.get("containers") is not None else None
        })
        return _obj


