# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.list_cloud_datastores200_response_all_of_datastores_inner_resource_permission_sites_inner import ListCloudDatastores200ResponseAllOfDatastoresInnerResourcePermissionSitesInner
from typing import Optional, Set
from typing_extensions import Self

class ListCloudDatastores200ResponseAllOfDatastoresInnerResourcePermission(BaseModel):
    """
    ListCloudDatastores200ResponseAllOfDatastoresInnerResourcePermission
    """ # noqa: E501
    all: Optional[StrictBool] = None
    sites: Optional[List[ListCloudDatastores200ResponseAllOfDatastoresInnerResourcePermissionSitesInner]] = None
    all_plans: Optional[StrictBool] = Field(default=None, alias="allPlans")
    plans: Optional[List[ListCloudDatastores200ResponseAllOfDatastoresInnerResourcePermissionSitesInner]] = None
    __properties: ClassVar[List[str]] = ["all", "sites", "allPlans", "plans"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListCloudDatastores200ResponseAllOfDatastoresInnerResourcePermission from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in sites (list)
        _items = []
        if self.sites:
            for _item_sites in self.sites:
                if _item_sites:
                    _items.append(_item_sites.to_dict())
            _dict['sites'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in plans (list)
        _items = []
        if self.plans:
            for _item_plans in self.plans:
                if _item_plans:
                    _items.append(_item_plans.to_dict())
            _dict['plans'] = _items
        # set to None if sites (nullable) is None
        # and model_fields_set contains the field
        if self.sites is None and "sites" in self.model_fields_set:
            _dict['sites'] = None

        # set to None if plans (nullable) is None
        # and model_fields_set contains the field
        if self.plans is None and "plans" in self.model_fields_set:
            _dict['plans'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListCloudDatastores200ResponseAllOfDatastoresInnerResourcePermission from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "all": obj.get("all"),
            "sites": [ListCloudDatastores200ResponseAllOfDatastoresInnerResourcePermissionSitesInner.from_dict(_item) for _item in obj["sites"]] if obj.get("sites") is not None else None,
            "allPlans": obj.get("allPlans"),
            "plans": [ListCloudDatastores200ResponseAllOfDatastoresInnerResourcePermissionSitesInner.from_dict(_item) for _item in obj["plans"]] if obj.get("plans") is not None else None
        })
        return _obj


