# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Optional
from morpheus.models.list_clouds200_response_all_of_zones_inner_config_any_of import ListClouds200ResponseAllOfZonesInnerConfigAnyOf
from morpheus.models.list_clouds200_response_all_of_zones_inner_config_any_of1 import ListClouds200ResponseAllOfZonesInnerConfigAnyOf1
from morpheus.models.list_clouds200_response_all_of_zones_inner_config_any_of2 import ListClouds200ResponseAllOfZonesInnerConfigAnyOf2
from morpheus.models.list_clouds200_response_all_of_zones_inner_config_any_of3 import ListClouds200ResponseAllOfZonesInnerConfigAnyOf3
from typing import Union, Any, List, Set, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal, Self
from pydantic import Field

LISTCLOUDS200RESPONSEALLOFZONESINNERCONFIG_ANY_OF_SCHEMAS = ["ListClouds200ResponseAllOfZonesInnerConfigAnyOf", "ListClouds200ResponseAllOfZonesInnerConfigAnyOf1", "ListClouds200ResponseAllOfZonesInnerConfigAnyOf2", "ListClouds200ResponseAllOfZonesInnerConfigAnyOf3"]

class ListClouds200ResponseAllOfZonesInnerConfig(BaseModel):
    """
    ListClouds200ResponseAllOfZonesInnerConfig
    """

    # data type: ListClouds200ResponseAllOfZonesInnerConfigAnyOf
    anyof_schema_1_validator: Optional[ListClouds200ResponseAllOfZonesInnerConfigAnyOf] = None
    # data type: ListClouds200ResponseAllOfZonesInnerConfigAnyOf1
    anyof_schema_2_validator: Optional[ListClouds200ResponseAllOfZonesInnerConfigAnyOf1] = None
    # data type: ListClouds200ResponseAllOfZonesInnerConfigAnyOf2
    anyof_schema_3_validator: Optional[ListClouds200ResponseAllOfZonesInnerConfigAnyOf2] = None
    # data type: ListClouds200ResponseAllOfZonesInnerConfigAnyOf3
    anyof_schema_4_validator: Optional[ListClouds200ResponseAllOfZonesInnerConfigAnyOf3] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[ListClouds200ResponseAllOfZonesInnerConfigAnyOf, ListClouds200ResponseAllOfZonesInnerConfigAnyOf1, ListClouds200ResponseAllOfZonesInnerConfigAnyOf2, ListClouds200ResponseAllOfZonesInnerConfigAnyOf3]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: Set[str] = { "ListClouds200ResponseAllOfZonesInnerConfigAnyOf", "ListClouds200ResponseAllOfZonesInnerConfigAnyOf1", "ListClouds200ResponseAllOfZonesInnerConfigAnyOf2", "ListClouds200ResponseAllOfZonesInnerConfigAnyOf3" }

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = ListClouds200ResponseAllOfZonesInnerConfig.model_construct()
        error_messages = []
        # validate data type: ListClouds200ResponseAllOfZonesInnerConfigAnyOf
        if not isinstance(v, ListClouds200ResponseAllOfZonesInnerConfigAnyOf):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ListClouds200ResponseAllOfZonesInnerConfigAnyOf`")
        else:
            return v

        # validate data type: ListClouds200ResponseAllOfZonesInnerConfigAnyOf1
        if not isinstance(v, ListClouds200ResponseAllOfZonesInnerConfigAnyOf1):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ListClouds200ResponseAllOfZonesInnerConfigAnyOf1`")
        else:
            return v

        # validate data type: ListClouds200ResponseAllOfZonesInnerConfigAnyOf2
        if not isinstance(v, ListClouds200ResponseAllOfZonesInnerConfigAnyOf2):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ListClouds200ResponseAllOfZonesInnerConfigAnyOf2`")
        else:
            return v

        # validate data type: ListClouds200ResponseAllOfZonesInnerConfigAnyOf3
        if not isinstance(v, ListClouds200ResponseAllOfZonesInnerConfigAnyOf3):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ListClouds200ResponseAllOfZonesInnerConfigAnyOf3`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in ListClouds200ResponseAllOfZonesInnerConfig with anyOf schemas: ListClouds200ResponseAllOfZonesInnerConfigAnyOf, ListClouds200ResponseAllOfZonesInnerConfigAnyOf1, ListClouds200ResponseAllOfZonesInnerConfigAnyOf2, ListClouds200ResponseAllOfZonesInnerConfigAnyOf3. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[ListClouds200ResponseAllOfZonesInnerConfigAnyOf] = None
        try:
            instance.actual_instance = ListClouds200ResponseAllOfZonesInnerConfigAnyOf.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[ListClouds200ResponseAllOfZonesInnerConfigAnyOf1] = None
        try:
            instance.actual_instance = ListClouds200ResponseAllOfZonesInnerConfigAnyOf1.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[ListClouds200ResponseAllOfZonesInnerConfigAnyOf2] = None
        try:
            instance.actual_instance = ListClouds200ResponseAllOfZonesInnerConfigAnyOf2.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[ListClouds200ResponseAllOfZonesInnerConfigAnyOf3] = None
        try:
            instance.actual_instance = ListClouds200ResponseAllOfZonesInnerConfigAnyOf3.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ListClouds200ResponseAllOfZonesInnerConfig with anyOf schemas: ListClouds200ResponseAllOfZonesInnerConfigAnyOf, ListClouds200ResponseAllOfZonesInnerConfigAnyOf1, ListClouds200ResponseAllOfZonesInnerConfigAnyOf2, ListClouds200ResponseAllOfZonesInnerConfigAnyOf3. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ListClouds200ResponseAllOfZonesInnerConfigAnyOf, ListClouds200ResponseAllOfZonesInnerConfigAnyOf1, ListClouds200ResponseAllOfZonesInnerConfigAnyOf2, ListClouds200ResponseAllOfZonesInnerConfigAnyOf3]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


