# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ListClusterContainers200ResponseAllOfContainersInnerStats(BaseModel):
    """
    ListClusterContainers200ResponseAllOfContainersInnerStats
    """ # noqa: E501
    ts: Optional[datetime] = None
    running: Optional[StrictBool] = None
    user_cpu_usage: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="userCpuUsage")
    system_cpu_usage: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="systemCpuUsage")
    used_memory: Optional[StrictInt] = Field(default=None, alias="usedMemory")
    max_memory: Optional[StrictInt] = Field(default=None, alias="maxMemory")
    cache_memory: Optional[StrictInt] = Field(default=None, alias="cacheMemory")
    max_storage: Optional[StrictInt] = Field(default=None, alias="maxStorage")
    used_storage: Optional[StrictInt] = Field(default=None, alias="usedStorage")
    read_iops: Optional[StrictInt] = Field(default=None, alias="readIOPS")
    write_iops: Optional[StrictInt] = Field(default=None, alias="writeIOPS")
    total_iops: Optional[StrictInt] = Field(default=None, alias="totalIOPS")
    net_tx_usage: Optional[StrictInt] = Field(default=None, alias="netTxUsage")
    net_rx_usage: Optional[StrictInt] = Field(default=None, alias="netRxUsage")
    __properties: ClassVar[List[str]] = ["ts", "running", "userCpuUsage", "systemCpuUsage", "usedMemory", "maxMemory", "cacheMemory", "maxStorage", "usedStorage", "readIOPS", "writeIOPS", "totalIOPS", "netTxUsage", "netRxUsage"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListClusterContainers200ResponseAllOfContainersInnerStats from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListClusterContainers200ResponseAllOfContainersInnerStats from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ts": obj.get("ts"),
            "running": obj.get("running"),
            "userCpuUsage": obj.get("userCpuUsage"),
            "systemCpuUsage": obj.get("systemCpuUsage"),
            "usedMemory": obj.get("usedMemory"),
            "maxMemory": obj.get("maxMemory"),
            "cacheMemory": obj.get("cacheMemory"),
            "maxStorage": obj.get("maxStorage"),
            "usedStorage": obj.get("usedStorage"),
            "readIOPS": obj.get("readIOPS"),
            "writeIOPS": obj.get("writeIOPS"),
            "totalIOPS": obj.get("totalIOPS"),
            "netTxUsage": obj.get("netTxUsage"),
            "netRxUsage": obj.get("netRxUsage")
        })
        return _obj


