# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ListCredentials200ResponseAllOfCredentialsInnerConfig(BaseModel):
    """
    ListCredentials200ResponseAllOfCredentialsInnerConfig
    """ # noqa: E501
    client_secret: Optional[StrictStr] = Field(default=None, alias="clientSecret")
    client_id: Optional[StrictStr] = Field(default=None, alias="clientId")
    client_auth: Optional[StrictStr] = Field(default=None, alias="clientAuth")
    scope: Optional[StrictStr] = None
    grant_type: Optional[StrictStr] = Field(default=None, alias="grantType")
    access_token_url: Optional[StrictStr] = Field(default=None, alias="accessTokenUrl")
    client_secret_hash: Optional[StrictStr] = Field(default=None, alias="clientSecretHash")
    __properties: ClassVar[List[str]] = ["clientSecret", "clientId", "clientAuth", "scope", "grantType", "accessTokenUrl", "clientSecretHash"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListCredentials200ResponseAllOfCredentialsInnerConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if client_secret (nullable) is None
        # and model_fields_set contains the field
        if self.client_secret is None and "client_secret" in self.model_fields_set:
            _dict['clientSecret'] = None

        # set to None if client_id (nullable) is None
        # and model_fields_set contains the field
        if self.client_id is None and "client_id" in self.model_fields_set:
            _dict['clientId'] = None

        # set to None if client_secret_hash (nullable) is None
        # and model_fields_set contains the field
        if self.client_secret_hash is None and "client_secret_hash" in self.model_fields_set:
            _dict['clientSecretHash'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListCredentials200ResponseAllOfCredentialsInnerConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "clientSecret": obj.get("clientSecret"),
            "clientId": obj.get("clientId"),
            "clientAuth": obj.get("clientAuth"),
            "scope": obj.get("scope"),
            "grantType": obj.get("grantType"),
            "accessTokenUrl": obj.get("accessTokenUrl"),
            "clientSecretHash": obj.get("clientSecretHash")
        })
        return _obj


