# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ListDeploymentVersions200ResponseAllOfVersionsInner(BaseModel):
    """
    ListDeploymentVersions200ResponseAllOfVersionsInner
    """ # noqa: E501
    id: Optional[StrictInt] = None
    deploy_type: Optional[StrictStr] = Field(default=None, alias="deployType")
    deployment_id: Optional[StrictInt] = Field(default=None, alias="deploymentId")
    fetch_url: Optional[StrictStr] = Field(default=None, alias="fetchUrl")
    git_url: Optional[StrictStr] = Field(default=None, alias="gitUrl")
    git_ref: Optional[StrictStr] = Field(default=None, alias="gitRef")
    user_version: Optional[StrictStr] = Field(default=None, alias="userVersion")
    version: Optional[StrictStr] = None
    status: Optional[StrictStr] = None
    date_created: Optional[datetime] = Field(default=None, alias="dateCreated")
    last_updated: Optional[datetime] = Field(default=None, alias="lastUpdated")
    __properties: ClassVar[List[str]] = ["id", "deployType", "deploymentId", "fetchUrl", "gitUrl", "gitRef", "userVersion", "version", "status", "dateCreated", "lastUpdated"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListDeploymentVersions200ResponseAllOfVersionsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if fetch_url (nullable) is None
        # and model_fields_set contains the field
        if self.fetch_url is None and "fetch_url" in self.model_fields_set:
            _dict['fetchUrl'] = None

        # set to None if git_url (nullable) is None
        # and model_fields_set contains the field
        if self.git_url is None and "git_url" in self.model_fields_set:
            _dict['gitUrl'] = None

        # set to None if git_ref (nullable) is None
        # and model_fields_set contains the field
        if self.git_ref is None and "git_ref" in self.model_fields_set:
            _dict['gitRef'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListDeploymentVersions200ResponseAllOfVersionsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "deployType": obj.get("deployType"),
            "deploymentId": obj.get("deploymentId"),
            "fetchUrl": obj.get("fetchUrl"),
            "gitUrl": obj.get("gitUrl"),
            "gitRef": obj.get("gitRef"),
            "userVersion": obj.get("userVersion"),
            "version": obj.get("version"),
            "status": obj.get("status"),
            "dateCreated": obj.get("dateCreated"),
            "lastUpdated": obj.get("lastUpdated")
        })
        return _obj


