# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ListHosts200ResponseAllOfServersInnerStats(BaseModel):
    """
    ListHosts200ResponseAllOfServersInnerStats
    """ # noqa: E501
    ts: Optional[datetime] = None
    free_swap: Optional[StrictInt] = Field(default=None, alias="freeSwap")
    used_swap: Optional[StrictInt] = Field(default=None, alias="usedSwap")
    cpu_idle_time: Optional[StrictInt] = Field(default=None, alias="cpuIdleTime")
    cpu_system_time: Optional[StrictInt] = Field(default=None, alias="cpuSystemTime")
    cpu_user_time: Optional[StrictInt] = Field(default=None, alias="cpuUserTime")
    cpu_total_time: Optional[StrictInt] = Field(default=None, alias="cpuTotalTime")
    max_memory: Optional[StrictInt] = Field(default=None, alias="maxMemory")
    used_memory: Optional[StrictInt] = Field(default=None, alias="usedMemory")
    max_storage: Optional[StrictInt] = Field(default=None, alias="maxStorage")
    used_storage: Optional[StrictInt] = Field(default=None, alias="usedStorage")
    reserved_storage: Optional[StrictInt] = Field(default=None, alias="reservedStorage")
    cpu_usage: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="cpuUsage")
    free_memory: Optional[StrictInt] = Field(default=None, alias="freeMemory")
    net_tx_usage: Optional[StrictInt] = Field(default=None, alias="netTxUsage")
    net_rx_usage: Optional[StrictInt] = Field(default=None, alias="netRxUsage")
    network_bandwidth: Optional[StrictInt] = Field(default=None, alias="networkBandwidth")
    __properties: ClassVar[List[str]] = ["ts", "freeSwap", "usedSwap", "cpuIdleTime", "cpuSystemTime", "cpuUserTime", "cpuTotalTime", "maxMemory", "usedMemory", "maxStorage", "usedStorage", "reservedStorage", "cpuUsage", "freeMemory", "netTxUsage", "netRxUsage", "networkBandwidth"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListHosts200ResponseAllOfServersInnerStats from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListHosts200ResponseAllOfServersInnerStats from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ts": obj.get("ts"),
            "freeSwap": obj.get("freeSwap"),
            "usedSwap": obj.get("usedSwap"),
            "cpuIdleTime": obj.get("cpuIdleTime"),
            "cpuSystemTime": obj.get("cpuSystemTime"),
            "cpuUserTime": obj.get("cpuUserTime"),
            "cpuTotalTime": obj.get("cpuTotalTime"),
            "maxMemory": obj.get("maxMemory"),
            "usedMemory": obj.get("usedMemory"),
            "maxStorage": obj.get("maxStorage"),
            "usedStorage": obj.get("usedStorage"),
            "reservedStorage": obj.get("reservedStorage"),
            "cpuUsage": obj.get("cpuUsage"),
            "freeMemory": obj.get("freeMemory"),
            "netTxUsage": obj.get("netTxUsage"),
            "netRxUsage": obj.get("netRxUsage"),
            "networkBandwidth": obj.get("networkBandwidth")
        })
        return _obj


