# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.list_integrations200_response_any_of_integrations_inner_any_of15_config_service_now_cmdb_class_mapping_inner import ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOf15ConfigServiceNowCmdbClassMappingInner
from typing import Optional, Set
from typing_extensions import Self

class ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOf15Config(BaseModel):
    """
    ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOf15Config
    """ # noqa: E501
    incident_access: Optional[StrictBool] = Field(default=None, alias="incidentAccess")
    request_access: Optional[StrictBool] = Field(default=None, alias="requestAccess")
    service_now_cmdb_business_object: Optional[StrictStr] = Field(default=None, alias="serviceNowCMDBBusinessObject")
    service_now_custom_cmdb_mapping: Optional[StrictStr] = Field(default=None, alias="serviceNowCustomCmdbMapping")
    service_now_cmdb_class_mapping: Optional[List[ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOf15ConfigServiceNowCmdbClassMappingInner]] = Field(default=None, alias="serviceNowCmdbClassMapping")
    web_service_import_url: Optional[StrictStr] = Field(default=None, alias="webServiceImportUrl")
    web_service_import_sys_id: Optional[StrictStr] = Field(default=None, alias="webServiceImportSysId")
    web_service_operation_url: Optional[StrictStr] = Field(default=None, alias="webServiceOperationUrl")
    cmdb_mode: Optional[StrictStr] = Field(default='TABLE', alias="cmdbMode")
    prepared_for_sync: Optional[StrictBool] = Field(default=None, alias="preparedForSync")
    __properties: ClassVar[List[str]] = ["incidentAccess", "requestAccess", "serviceNowCMDBBusinessObject", "serviceNowCustomCmdbMapping", "serviceNowCmdbClassMapping", "webServiceImportUrl", "webServiceImportSysId", "webServiceOperationUrl", "cmdbMode", "preparedForSync"]

    @field_validator('cmdb_mode')
    def cmdb_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['TABLE', 'IRE']):
            raise ValueError("must be one of enum values ('TABLE', 'IRE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOf15Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in service_now_cmdb_class_mapping (list)
        _items = []
        if self.service_now_cmdb_class_mapping:
            for _item_service_now_cmdb_class_mapping in self.service_now_cmdb_class_mapping:
                if _item_service_now_cmdb_class_mapping:
                    _items.append(_item_service_now_cmdb_class_mapping.to_dict())
            _dict['serviceNowCmdbClassMapping'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOf15Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "incidentAccess": obj.get("incidentAccess"),
            "requestAccess": obj.get("requestAccess"),
            "serviceNowCMDBBusinessObject": obj.get("serviceNowCMDBBusinessObject"),
            "serviceNowCustomCmdbMapping": obj.get("serviceNowCustomCmdbMapping"),
            "serviceNowCmdbClassMapping": [ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOf15ConfigServiceNowCmdbClassMappingInner.from_dict(_item) for _item in obj["serviceNowCmdbClassMapping"]] if obj.get("serviceNowCmdbClassMapping") is not None else None,
            "webServiceImportUrl": obj.get("webServiceImportUrl"),
            "webServiceImportSysId": obj.get("webServiceImportSysId"),
            "webServiceOperationUrl": obj.get("webServiceOperationUrl"),
            "cmdbMode": obj.get("cmdbMode") if obj.get("cmdbMode") is not None else 'TABLE',
            "preparedForSync": obj.get("preparedForSync")
        })
        return _obj


