# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOfConfig(BaseModel):
    """
    ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOfConfig
    """ # noqa: E501
    inventory: Optional[StrictStr] = None
    default_branch: Optional[StrictStr] = Field(default=None, alias="defaultBranch")
    cache_enabled: Optional[StrictStr] = Field(default=None, alias="cacheEnabled")
    ansible_playbooks: Optional[StrictStr] = Field(default=None, alias="ansiblePlaybooks")
    ansible_roles: Optional[StrictStr] = Field(default=None, alias="ansibleRoles")
    ansible_group_vars: Optional[StrictStr] = Field(default=None, alias="ansibleGroupVars")
    ansible_host_vars: Optional[StrictStr] = Field(default=None, alias="ansibleHostVars")
    ansible_command_bus: Optional[StrictBool] = Field(default=None, alias="ansibleCommandBus")
    ansible_verbose: Optional[StrictBool] = Field(default=None, alias="ansibleVerbose")
    ansible_galaxy_enabled: Optional[StrictBool] = Field(default=None, alias="ansibleGalaxyEnabled")
    ansible_default_branch: Optional[StrictStr] = Field(default=None, alias="ansibleDefaultBranch")
    __properties: ClassVar[List[str]] = ["inventory", "defaultBranch", "cacheEnabled", "ansiblePlaybooks", "ansibleRoles", "ansibleGroupVars", "ansibleHostVars", "ansibleCommandBus", "ansibleVerbose", "ansibleGalaxyEnabled", "ansibleDefaultBranch"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOfConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if inventory (nullable) is None
        # and model_fields_set contains the field
        if self.inventory is None and "inventory" in self.model_fields_set:
            _dict['inventory'] = None

        # set to None if cache_enabled (nullable) is None
        # and model_fields_set contains the field
        if self.cache_enabled is None and "cache_enabled" in self.model_fields_set:
            _dict['cacheEnabled'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListIntegrations200ResponseAnyOfIntegrationsInnerAnyOfConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "inventory": obj.get("inventory"),
            "defaultBranch": obj.get("defaultBranch"),
            "cacheEnabled": obj.get("cacheEnabled"),
            "ansiblePlaybooks": obj.get("ansiblePlaybooks"),
            "ansibleRoles": obj.get("ansibleRoles"),
            "ansibleGroupVars": obj.get("ansibleGroupVars"),
            "ansibleHostVars": obj.get("ansibleHostVars"),
            "ansibleCommandBus": obj.get("ansibleCommandBus"),
            "ansibleVerbose": obj.get("ansibleVerbose"),
            "ansibleGalaxyEnabled": obj.get("ansibleGalaxyEnabled"),
            "ansibleDefaultBranch": obj.get("ansibleDefaultBranch")
        })
        return _obj


