# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ListTasks200ResponseAllOfTasksInnerAnyOf2TaskOptions(BaseModel):
    """
    ListTasks200ResponseAllOfTasksInnerAnyOf2TaskOptions
    """ # noqa: E501
    chef_data_key: Optional[StrictStr] = Field(default=None, alias="chefDataKey")
    chef_data_key_hash: Optional[StrictStr] = Field(default=None, alias="chefDataKeyHash")
    chef_run_list: Optional[StrictStr] = Field(default=None, alias="chefRunList")
    local_script_git_ref: Optional[StrictStr] = Field(default=None, alias="localScriptGitRef")
    chef_data_key_path: Optional[StrictStr] = Field(default=None, alias="chefDataKeyPath")
    local_script_git_id: Optional[StrictStr] = Field(default=None, alias="localScriptGitId")
    port: Optional[StrictStr] = None
    chef_env: Optional[StrictStr] = Field(default=None, alias="chefEnv")
    chef_node_name: Optional[StrictStr] = Field(default=None, alias="chefNodeName")
    host: Optional[StrictStr] = None
    ssh_key: Optional[StrictStr] = Field(default=None, alias="sshKey")
    username: Optional[StrictStr] = None
    password: Optional[StrictStr] = None
    password_hash: Optional[StrictStr] = Field(default=None, alias="passwordHash")
    chef_attributes: Optional[StrictStr] = Field(default=None, alias="chefAttributes")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["chefDataKey", "chefDataKeyHash", "chefRunList", "localScriptGitRef", "chefDataKeyPath", "localScriptGitId", "port", "chefEnv", "chefNodeName", "host", "sshKey", "username", "password", "passwordHash", "chefAttributes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListTasks200ResponseAllOfTasksInnerAnyOf2TaskOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if chef_data_key (nullable) is None
        # and model_fields_set contains the field
        if self.chef_data_key is None and "chef_data_key" in self.model_fields_set:
            _dict['chefDataKey'] = None

        # set to None if chef_data_key_hash (nullable) is None
        # and model_fields_set contains the field
        if self.chef_data_key_hash is None and "chef_data_key_hash" in self.model_fields_set:
            _dict['chefDataKeyHash'] = None

        # set to None if chef_run_list (nullable) is None
        # and model_fields_set contains the field
        if self.chef_run_list is None and "chef_run_list" in self.model_fields_set:
            _dict['chefRunList'] = None

        # set to None if local_script_git_ref (nullable) is None
        # and model_fields_set contains the field
        if self.local_script_git_ref is None and "local_script_git_ref" in self.model_fields_set:
            _dict['localScriptGitRef'] = None

        # set to None if chef_data_key_path (nullable) is None
        # and model_fields_set contains the field
        if self.chef_data_key_path is None and "chef_data_key_path" in self.model_fields_set:
            _dict['chefDataKeyPath'] = None

        # set to None if local_script_git_id (nullable) is None
        # and model_fields_set contains the field
        if self.local_script_git_id is None and "local_script_git_id" in self.model_fields_set:
            _dict['localScriptGitId'] = None

        # set to None if port (nullable) is None
        # and model_fields_set contains the field
        if self.port is None and "port" in self.model_fields_set:
            _dict['port'] = None

        # set to None if chef_env (nullable) is None
        # and model_fields_set contains the field
        if self.chef_env is None and "chef_env" in self.model_fields_set:
            _dict['chefEnv'] = None

        # set to None if chef_node_name (nullable) is None
        # and model_fields_set contains the field
        if self.chef_node_name is None and "chef_node_name" in self.model_fields_set:
            _dict['chefNodeName'] = None

        # set to None if host (nullable) is None
        # and model_fields_set contains the field
        if self.host is None and "host" in self.model_fields_set:
            _dict['host'] = None

        # set to None if ssh_key (nullable) is None
        # and model_fields_set contains the field
        if self.ssh_key is None and "ssh_key" in self.model_fields_set:
            _dict['sshKey'] = None

        # set to None if username (nullable) is None
        # and model_fields_set contains the field
        if self.username is None and "username" in self.model_fields_set:
            _dict['username'] = None

        # set to None if password (nullable) is None
        # and model_fields_set contains the field
        if self.password is None and "password" in self.model_fields_set:
            _dict['password'] = None

        # set to None if password_hash (nullable) is None
        # and model_fields_set contains the field
        if self.password_hash is None and "password_hash" in self.model_fields_set:
            _dict['passwordHash'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListTasks200ResponseAllOfTasksInnerAnyOf2TaskOptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chefDataKey": obj.get("chefDataKey"),
            "chefDataKeyHash": obj.get("chefDataKeyHash"),
            "chefRunList": obj.get("chefRunList"),
            "localScriptGitRef": obj.get("localScriptGitRef"),
            "chefDataKeyPath": obj.get("chefDataKeyPath"),
            "localScriptGitId": obj.get("localScriptGitId"),
            "port": obj.get("port"),
            "chefEnv": obj.get("chefEnv"),
            "chefNodeName": obj.get("chefNodeName"),
            "host": obj.get("host"),
            "sshKey": obj.get("sshKey"),
            "username": obj.get("username"),
            "password": obj.get("password"),
            "passwordHash": obj.get("passwordHash"),
            "chefAttributes": obj.get("chefAttributes")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


