# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.max_memory_policy_type_configuration_max_memory import MaxMemoryPolicyTypeConfigurationMaxMemory
from typing import Optional, Set
from typing_extensions import Self

class MaxMemoryPolicyTypeConfiguration1(BaseModel):
    """
    Configuration settings for the following policy types: - Max Memory 
    """ # noqa: E501
    max_memory: Optional[MaxMemoryPolicyTypeConfigurationMaxMemory] = Field(default=None, alias="maxMemory")
    exclude_containers: Optional[StrictStr] = Field(default='off', description="Set to on to exclude containers", alias="excludeContainers")
    __properties: ClassVar[List[str]] = ["maxMemory", "excludeContainers"]

    @field_validator('exclude_containers')
    def exclude_containers_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['on', 'off']):
            raise ValueError("must be one of enum values ('on', 'off')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MaxMemoryPolicyTypeConfiguration1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of max_memory
        if self.max_memory:
            _dict['maxMemory'] = self.max_memory.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MaxMemoryPolicyTypeConfiguration1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "maxMemory": MaxMemoryPolicyTypeConfigurationMaxMemory.from_dict(obj["maxMemory"]) if obj.get("maxMemory") is not None else None,
            "excludeContainers": obj.get("excludeContainers") if obj.get("excludeContainers") is not None else 'off'
        })
        return _obj


