# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.add_instance200_response_all_of_one_of_instance_config_instance_type import AddInstance200ResponseAllOfOneOfInstanceConfigInstanceType
from morpheus.models.create_network_pool_request_network_pool_ip_ranges_inner import CreateNetworkPoolRequestNetworkPoolIpRangesInner
from typing import Optional, Set
from typing_extensions import Self

class NetworkPoolCreate(BaseModel):
    """
    NetworkPoolCreate
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Name")
    type: Optional[AddInstance200ResponseAllOfOneOfInstanceConfigInstanceType] = None
    ip_ranges: Optional[List[CreateNetworkPoolRequestNetworkPoolIpRangesInner]] = Field(default=None, description="Array of IP range objects. Type 'morpheus' expects startAddress and endAddress. Type 'morpheusipv6' expects a cidrIPv6.", alias="ipRanges")
    config: Optional[Dict[str, Any]] = Field(default=None, description="Configuration object with parameters that vary by pool type.")
    __properties: ClassVar[List[str]] = ["name", "type", "ipRanges", "config"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NetworkPoolCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of type
        if self.type:
            _dict['type'] = self.type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in ip_ranges (list)
        _items = []
        if self.ip_ranges:
            for _item_ip_ranges in self.ip_ranges:
                if _item_ip_ranges:
                    _items.append(_item_ip_ranges.to_dict())
            _dict['ipRanges'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NetworkPoolCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "type": AddInstance200ResponseAllOfOneOfInstanceConfigInstanceType.from_dict(obj["type"]) if obj.get("type") is not None else None,
            "ipRanges": [CreateNetworkPoolRequestNetworkPoolIpRangesInner.from_dict(_item) for _item in obj["ipRanges"]] if obj.get("ipRanges") is not None else None,
            "config": obj.get("config")
        })
        return _obj


