# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List
from morpheus.models.create_networks_request_network_config_any_of1_zone_pool import CreateNetworksRequestNetworkConfigAnyOf1ZonePool
from typing import Optional, Set
from typing_extensions import Self

class NetworkTypeAwsConfig(BaseModel):
    """
    NetworkTypeAwsConfig
    """ # noqa: E501
    availability_zone: StrictStr = Field(description="Availability Zone Name", alias="availabilityZone")
    cidr: StrictStr = Field(description="Network CIDR")
    assign_public_ip: StrictBool = Field(description="Assign public IPs by default.", alias="assignPublicIp")
    zone_pool: CreateNetworksRequestNetworkConfigAnyOf1ZonePool = Field(alias="zonePool")
    __properties: ClassVar[List[str]] = ["availabilityZone", "cidr", "assignPublicIp", "zonePool"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NetworkTypeAwsConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of zone_pool
        if self.zone_pool:
            _dict['zonePool'] = self.zone_pool.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NetworkTypeAwsConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "availabilityZone": obj.get("availabilityZone"),
            "cidr": obj.get("cidr"),
            "assignPublicIp": obj.get("assignPublicIp"),
            "zonePool": CreateNetworksRequestNetworkConfigAnyOf1ZonePool.from_dict(obj["zonePool"]) if obj.get("zonePool") is not None else None
        })
        return _obj


