# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Setup200Response(BaseModel):
    """
    Setup200Response
    """ # noqa: E501
    success: Optional[StrictBool] = None
    build_version: Optional[StrictStr] = Field(default=None, description="Morpheus build version that the server is running.", alias="buildVersion")
    uuid: Optional[StrictStr] = Field(default=None, description="The Appliance Unique ID that is auto generated.")
    appliance_url: Optional[StrictStr] = Field(default=None, description="The Appliance Server URL as defined under Appliance Settings.", alias="applianceUrl")
    setup_needed: Optional[StrictBool] = Field(default=None, description="Flag to determine if the appliance has been setup, only true when appliance is a fresh install and has not been initialized.", alias="setupNeeded")
    __properties: ClassVar[List[str]] = ["success", "buildVersion", "uuid", "applianceUrl", "setupNeeded"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Setup200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Setup200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "success": obj.get("success"),
            "buildVersion": obj.get("buildVersion"),
            "uuid": obj.get("uuid"),
            "applianceUrl": obj.get("applianceUrl"),
            "setupNeeded": obj.get("setupNeeded")
        })
        return _obj


