# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UpdateInstanceNetworkInterface200ResponseAllOfOneOfServerComputeServerType(BaseModel):
    """
    UpdateInstanceNetworkInterface200ResponseAllOfOneOfServerComputeServerType
    """ # noqa: E501
    id: Optional[StrictInt] = None
    code: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    platform: Optional[StrictStr] = None
    node_type: Optional[StrictStr] = Field(default=None, alias="nodeType")
    managed: Optional[StrictBool] = None
    enabled: Optional[StrictBool] = None
    vm_hypervisor: Optional[StrictBool] = Field(default=None, alias="vmHypervisor")
    container_hypervisor: Optional[StrictBool] = Field(default=None, alias="containerHypervisor")
    display_order: Optional[StrictInt] = Field(default=None, alias="displayOrder")
    selectable: Optional[StrictBool] = None
    control_power: Optional[StrictBool] = Field(default=None, alias="controlPower")
    control_suspend: Optional[StrictBool] = Field(default=None, alias="controlSuspend")
    has_agent: Optional[StrictBool] = Field(default=None, alias="hasAgent")
    creatable: Optional[StrictBool] = None
    option_types: Optional[List[Dict[str, Any]]] = Field(default=None, alias="optionTypes")
    __properties: ClassVar[List[str]] = ["id", "code", "name", "description", "platform", "nodeType", "managed", "enabled", "vmHypervisor", "containerHypervisor", "displayOrder", "selectable", "controlPower", "controlSuspend", "hasAgent", "creatable", "optionTypes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateInstanceNetworkInterface200ResponseAllOfOneOfServerComputeServerType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateInstanceNetworkInterface200ResponseAllOfOneOfServerComputeServerType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "code": obj.get("code"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "platform": obj.get("platform"),
            "nodeType": obj.get("nodeType"),
            "managed": obj.get("managed"),
            "enabled": obj.get("enabled"),
            "vmHypervisor": obj.get("vmHypervisor"),
            "containerHypervisor": obj.get("containerHypervisor"),
            "displayOrder": obj.get("displayOrder"),
            "selectable": obj.get("selectable"),
            "controlPower": obj.get("controlPower"),
            "controlSuspend": obj.get("controlSuspend"),
            "hasAgent": obj.get("hasAgent"),
            "creatable": obj.get("creatable"),
            "optionTypes": obj.get("optionTypes")
        })
        return _obj


