# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.get_instance_threshold200_response_instance_schedules_inner import GetInstanceThreshold200ResponseInstanceSchedulesInner
from morpheus.models.get_instance_threshold200_response_instance_threshold import GetInstanceThreshold200ResponseInstanceThreshold
from typing import Optional, Set
from typing_extensions import Self

class UpdateInstanceThreshold200Response(BaseModel):
    """
    UpdateInstanceThreshold200Response
    """ # noqa: E501
    instance_threshold: Optional[GetInstanceThreshold200ResponseInstanceThreshold] = Field(default=None, alias="instanceThreshold")
    instance_schedules: Optional[List[GetInstanceThreshold200ResponseInstanceSchedulesInner]] = Field(default=None, alias="instanceSchedules")
    success: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["instanceThreshold", "instanceSchedules", "success"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateInstanceThreshold200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of instance_threshold
        if self.instance_threshold:
            _dict['instanceThreshold'] = self.instance_threshold.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in instance_schedules (list)
        _items = []
        if self.instance_schedules:
            for _item_instance_schedules in self.instance_schedules:
                if _item_instance_schedules:
                    _items.append(_item_instance_schedules.to_dict())
            _dict['instanceSchedules'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateInstanceThreshold200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "instanceThreshold": GetInstanceThreshold200ResponseInstanceThreshold.from_dict(obj["instanceThreshold"]) if obj.get("instanceThreshold") is not None else None,
            "instanceSchedules": [GetInstanceThreshold200ResponseInstanceSchedulesInner.from_dict(_item) for _item in obj["instanceSchedules"]] if obj.get("instanceSchedules") is not None else None,
            "success": obj.get("success")
        })
        return _obj


