# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.add_price_sets_request_price_set_zone import AddPriceSetsRequestPriceSetZone
from morpheus.models.add_price_sets_request_price_set_zone_pool import AddPriceSetsRequestPriceSetZonePool
from typing import Optional, Set
from typing_extensions import Self

class UpdatePriceSetsRequestPriceSet(BaseModel):
    """
    UpdatePriceSetsRequestPriceSet
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Price set name")
    code: Optional[StrictStr] = Field(default=None, description="Price set code. Must be unique.")
    region_code: Optional[StrictStr] = Field(default=None, description="Price set region code", alias="regionCode")
    zone: Optional[AddPriceSetsRequestPriceSetZone] = None
    zone_pool: Optional[AddPriceSetsRequestPriceSetZonePool] = Field(default=None, alias="zonePool")
    price_unit: Optional[StrictStr] = Field(default=None, description="Price Unit", alias="priceUnit")
    type: Optional[StrictStr] = Field(default=None, description="Price set type")
    prices: Optional[List[StrictInt]] = None
    __properties: ClassVar[List[str]] = ["name", "code", "regionCode", "zone", "zonePool", "priceUnit", "type", "prices"]

    @field_validator('price_unit')
    def price_unit_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['minute', 'hour', 'day', 'month', 'year', 'two year', 'three year', 'four year', 'five year']):
            raise ValueError("must be one of enum values ('minute', 'hour', 'day', 'month', 'year', 'two year', 'three year', 'four year', 'five year')")
        return value

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['fixed', 'compute_plus_storage', 'component', 'load_balancer', 'snapshot', 'virtual_image', 'software_or_service']):
            raise ValueError("must be one of enum values ('fixed', 'compute_plus_storage', 'component', 'load_balancer', 'snapshot', 'virtual_image', 'software_or_service')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdatePriceSetsRequestPriceSet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of zone
        if self.zone:
            _dict['zone'] = self.zone.to_dict()
        # override the default output from pydantic by calling `to_dict()` of zone_pool
        if self.zone_pool:
            _dict['zonePool'] = self.zone_pool.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdatePriceSetsRequestPriceSet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "code": obj.get("code"),
            "regionCode": obj.get("regionCode"),
            "zone": AddPriceSetsRequestPriceSetZone.from_dict(obj["zone"]) if obj.get("zone") is not None else None,
            "zonePool": AddPriceSetsRequestPriceSetZonePool.from_dict(obj["zonePool"]) if obj.get("zonePool") is not None else None,
            "priceUnit": obj.get("priceUnit"),
            "type": obj.get("type"),
            "prices": obj.get("prices")
        })
        return _obj


