# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.update_instance_network_interface200_response_all_of_one_of_network_interface import UpdateInstanceNetworkInterface200ResponseAllOfOneOfNetworkInterface
from morpheus.models.update_instance_network_interface200_response_all_of_one_of_server import UpdateInstanceNetworkInterface200ResponseAllOfOneOfServer
from typing import Optional, Set
from typing_extensions import Self

class UpdateServerNetworkInterface200Response(BaseModel):
    """
    UpdateServerNetworkInterface200Response
    """ # noqa: E501
    network_interface: Optional[UpdateInstanceNetworkInterface200ResponseAllOfOneOfNetworkInterface] = Field(default=None, alias="networkInterface")
    interface_type: Optional[StrictStr] = Field(default=None, alias="interfaceType")
    net_id: Optional[StrictInt] = Field(default=None, alias="netId")
    server: Optional[UpdateInstanceNetworkInterface200ResponseAllOfOneOfServer] = None
    success: Optional[StrictBool] = None
    errors: Optional[Dict[str, Any]] = None
    __properties: ClassVar[List[str]] = ["networkInterface", "interfaceType", "netId", "server", "success", "errors"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateServerNetworkInterface200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of network_interface
        if self.network_interface:
            _dict['networkInterface'] = self.network_interface.to_dict()
        # override the default output from pydantic by calling `to_dict()` of server
        if self.server:
            _dict['server'] = self.server.to_dict()
        # set to None if errors (nullable) is None
        # and model_fields_set contains the field
        if self.errors is None and "errors" in self.model_fields_set:
            _dict['errors'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateServerNetworkInterface200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "networkInterface": UpdateInstanceNetworkInterface200ResponseAllOfOneOfNetworkInterface.from_dict(obj["networkInterface"]) if obj.get("networkInterface") is not None else None,
            "interfaceType": obj.get("interfaceType"),
            "netId": obj.get("netId"),
            "server": UpdateInstanceNetworkInterface200ResponseAllOfOneOfServer.from_dict(obj["server"]) if obj.get("server") is not None else None,
            "success": obj.get("success"),
            "errors": obj.get("errors")
        })
        return _obj


