# coding: utf-8

"""
    Morpheus API

    Morpheus is a powerful cloud management tool that provides provisioning, monitoring, logging, backups, and application deployment strategies.  This document describes the Morpheus API protocol and the available endpoints. Sections are organized in the same manner as they appear in the Morpheus UI.

    The version of the OpenAPI document: 8.0.8
    Contact: dev@morpheusdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from morpheus.models.list_user_settings200_response_all_of_access_tokens_inner import ListUserSettings200ResponseAllOfAccessTokensInner
from morpheus.models.list_user_settings200_response_all_of_user import ListUserSettings200ResponseAllOfUser
from typing import Optional, Set
from typing_extensions import Self

class UserSettings(BaseModel):
    """
    UserSettings
    """ # noqa: E501
    user: Optional[ListUserSettings200ResponseAllOfUser] = None
    access_tokens: Optional[List[ListUserSettings200ResponseAllOfAccessTokensInner]] = Field(default=None, alias="accessTokens")
    __properties: ClassVar[List[str]] = ["user", "accessTokens"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in access_tokens (list)
        _items = []
        if self.access_tokens:
            for _item_access_tokens in self.access_tokens:
                if _item_access_tokens:
                    _items.append(_item_access_tokens.to_dict())
            _dict['accessTokens'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "user": ListUserSettings200ResponseAllOfUser.from_dict(obj["user"]) if obj.get("user") is not None else None,
            "accessTokens": [ListUserSettings200ResponseAllOfAccessTokensInner.from_dict(_item) for _item in obj["accessTokens"]] if obj.get("accessTokens") is not None else None
        })
        return _obj


